/** 
 *   FIXME ....
 *
 *   Based on macros from asm/ioctl.h (by H.H. Bergman.)
 *
 *   (c) Copyright 2004 Federico Bareilles <fede@iar.unlp.edu.ar>,
 *   Instituto Argentino de Radio Astronomia (IAR).
 *
 *   This program is free software; you can redistribute it and/or
 *   modify it under the terms of the GNU General Public License as
 *   published by the Free Software Foundation; either version 2 of
 *   the License, or (at your option) any later version.
 *     
 *   The author does NOT admit liability nor provide warranty for any
 *   of this software. This material is provided "AS-IS" in the hope
 *   that it may be useful for others.
 *
 *   TODO: ??? 
 **/

#ifndef _CMCTL_H
#define _CMCTL_H

#define _CMC_NRBITS     8
#define _CMC_TYPEBITS   8
#define _CMC_SIZEBITS   14
#define _CMC_DATABITS   2

#define _CMC_NRMASK     ((1 << _CMC_NRBITS)-1)
#define _CMC_TYPEMASK   ((1 << _CMC_TYPEBITS)-1)
#define _CMC_SIZEMASK   ((1 << _CMC_SIZEBITS)-1)
#define _CMC_DATAMASK   ((1 << _CMC_DATABITS)-1)

#define _CMC_NRSHIFT    0
#define _CMC_TYPESHIFT  (_CMC_NRSHIFT+_CMC_NRBITS)
#define _CMC_SIZESHIFT  (_CMC_TYPESHIFT+_CMC_TYPEBITS)
#define _CMC_DATASHIFT  (_CMC_SIZESHIFT+_CMC_SIZEBITS)

/*
 * data bits.
 */

#define _CMC_NONE       0U
#define _CMC_ARG        1U
//#define _CMC_READ       2U

#define _CMC(data,type,nr,size) \
        (((data)  << _CMC_DATASHIFT) | \
         ((type) << _CMC_TYPESHIFT) | \
         ((nr)   << _CMC_NRSHIFT) | \
         ((size) << _CMC_SIZESHIFT))

/* used to create numbers */
#define _CM(type,nr)            _CMC(_CMC_NONE,(type),(nr),0)
#define _CMA(type,nr,size)      _CMC(_CMC_ARG,(type),(nr),sizeof(size))
//#define _CMW(type,nr,size)      _CMC(_CMC_WRITE,(type),(nr),sizeof(size))
//#define _CMWR(type,nr,size)     _CMC(_CMC_READ|_CMC_WRITE,(type),(nr),sizeof(size))

/* used to decode cm numbers.. */
#define _CMC_DATA(nr)           (((nr) >> _CMC_DATASHIFT) & _CMC_DATAMASK)
#define _CMC_TYPE(nr)           (((nr) >> _CMC_TYPESHIFT) & _CMC_TYPEMASK)
#define _CMC_NR(nr)             (((nr) >> _CMC_NRSHIFT) & _CMC_NRMASK)
#define _CMC_SIZE(nr)           (((nr) >> _CMC_SIZESHIFT) & _CMC_SIZEMASK)


#endif /* ifndef _CMCTL_H */

